#define CARDPAY_DA_UART		uart_port1
#define CARDPAY_DA_MAX_LEN	255
#define MOD_CARDPAY			MOD_MMI

U8 gDAbuffer[CARDPAY_DA_MAX_LEN];
U16 gDAbuflen;

extern kal_uint8 CardPaySmHandle;
extern void HuayuRFIDHardInit(void);
extern void HuayuRFIDHardOff(void);

void CardPayDAUartInit(void)
{
#ifdef MMI_ON_HARDWARE_P
	/* UART init */
	UART_SetOwner(CARDPAY_DA_UART, MOD_CARDPAY);
	UART_SetBaudRate(CARDPAY_DA_UART, UART_BAUD_57600, MOD_CARDPAY);
	L1SM_SleepDisable(CardPaySmHandle);
#endif
	SetProtocolEventHandler(CardPayDAUartHandler, MSG_ID_UART_READY_TO_READ_IND);
}

U16 CardPayDAUartRead(U8 *buf, U16 maxlen, UART_PORT port, module_type ownerid)
{
	U8 status = 0;
	U16 avail;
	U16 retlen = 0, readlen;

#ifdef MMI_ON_HARDWARE_P
	while ((avail = UART_GetBytesAvail(port) && retlen <= maxlen) > 0)
	{
		if (avail + retlen > maxlen)
			avail = maxlen - retlen;

		readlen = UART_GetBytes(port, (kal_uint8 *)(buf+retlen),
			(kal_uint16)avail, &status, ownerid);
		retlen +=  readlen;
	}

	//UART_ClrTxBuffer(port, ownerid);
	UART_ClrRxBuffer(port, ownerid);
#endif

	return retlen;
}

U8 CardPayDAUartWrite(U8 *buf, U16 buflen, UART_PORT port, module_type ownerid)
{
	U8 ret = FALSE;
	U16 sent;
	module_type UART_Owner = 0;

	sent = 0;

#ifdef MMI_ON_HARDWARE_P
	UART_Purge(port, RX_BUF, ownerid);
	UART_Purge(port, TX_BUF, ownerid);
	UART_ClrTxBuffer(port, ownerid);
	UART_ClrRxBuffer(port, ownerid);

	sent = UART_PutBytes(port, (kal_uint8 *)buf, (kal_uint16)buflen, ownerid);
#endif

	if (sent == buflen)
		ret = TRUE;

	return ret ;
}

void CardPayDAUartHandler(void *msg)
{
#ifdef MMI_ON_HARDWARE_P
	uart_ready_to_read_ind_struct *tmp = (uart_ready_to_read_ind_struct *)msg;

    if (UART_GetOwnerID(tmp->port) != MOD_CARDPAY)
		return ;

	if (tmp->port != CARDPAY_DA_UART)
		return ;

	gDAbuflen = CardPayDAUartRead(gDAbuffer, CARDPAY_DA_MAX_LEN, CARDPAY_DA_UART, MOD_CARDPAY);

	if (CardPayDAUartReadDone())
		CardPayDADataProcess();
#endif
}

U8 CardPayDAUartReadDone(void)
{
	return 1;
}

void CardPayDADataProcess(void)
{
	if (gDAbuflen > 0) {
		//CardPayDAUartWrite(gDAbuffer, gDAbuflen, CARDPAY_DA_UART, MOD_CARDPAY);
		// update display
		CardPayDAUpdateInfo(gDAbuffer, gDAbuflen);
		
	}
	CARDPAY_DEBUG_HEX(gDAbuffer, gDAbuflen);
} 

